<template>
  <div class="createPost-container">
    <el-form ref="postForm" :model="postForm" :rules="rules" class="form-container">

      <sticky :class-name="'sub-navbar '+postForm.status">
        <el-button v-loading="loading" style="margin-left: 10px;" type="success" @click="submitForm">保存
        </el-button>
      </sticky>
      <div class="createPost-main-container">
        <el-row :gutter="20">
          <el-card class="box-card">

            <div slot="header" class="clearfix">
              <span>小组相关</span>
            </div>

            <el-row>
              <el-col :span="24">
                <el-form-item style="margin-bottom: 20px;" prop="name">
                  <MDinput v-model="postForm.name" :maxlength="100" name="name" required>
                    小组名称
                  </MDinput>
                </el-form-item>

                <div class="postInfo-container">
                  <el-row>
                    <el-col :span="8">
                      <el-form-item label-width="75px" label="明星称号:" class="postInfo-container-item">
                        <el-select
                          v-model="postForm.star"
                          :remote-method="getRemoteStarList"
                          filterable
                          remote
                          multiple
                          reserve-keyword
                          value-key="id"
                          placeholder="搜索明星"
                          style="width: 100%">
                          <el-option v-for="(item,index) in starListOptions" :key="item+index" :label="item.name"
                                     :value="item.id"/>
                        </el-select>
                      </el-form-item>
                    </el-col>
                    <el-col :span="8">
                      <el-form-item label-width="75px" label="小组组长:" class="postInfo-container-item">
                        <el-select v-model="postForm.user_id" :remote-method="getRemoteUserList" filterable remote
                                   value-key="id"
                                   placeholder="搜索用户" style="width: 100%">
                          <el-option v-for="(item,index) in userListOptions" :key="item+index" :label="item.name"
                                     :value="item.id"/>
                        </el-select>
                      </el-form-item>
                    </el-col>
                    <el-col :span="8">
                      <el-form-item style="margin-bottom: 20px;" label-width="75px" label="组员数量:" prop="user_nums">
                        <el-input v-model="postForm.user_nums" type="number" placeholder="请输入内容" style="width: 230px;"
                                  disabled/>
                      </el-form-item>
                    </el-col>
                  </el-row>
                  <el-row>
                    <el-col :span="8">
                      <el-form-item style="margin-bottom: 20px;" label-width="75px" label="下线小组:">
                        <el-radio-group v-model="postForm.is_online">
                          <el-radio :label="1">是</el-radio>
                          <el-radio :label="0">否</el-radio>
                        </el-radio-group>
                      </el-form-item>
                    </el-col>
                    <el-col :span="8">
                      <el-form-item style="margin-bottom: 20px;" label-width="75px" label="推荐小组:">
                        <el-radio-group v-model="postForm.is_recommend">
                          <el-radio :label="1">是</el-radio>
                          <el-radio :label="0">否</el-radio>
                        </el-radio-group>
                      </el-form-item>
                    </el-col>
                    <el-col :span="8">

                    </el-col>
                  </el-row>
                </div>
              </el-col>
            </el-row>
            <el-form-item style="margin-bottom: 20px;" label-width="75px" label="小组简介:">
              <el-input :rows="1" v-model="postForm.description" type="textarea" class="article-textarea" autosize
                        placeholder="请输入内容"/>
              <span v-show="contentShortLength" class="word-counter">{{ contentShortLength }}字</span>
            </el-form-item>

          </el-card>
        </el-row>

        <el-row :gutter="20" style="margin-top:50px;">
          <el-card class="box-card">
            <div slot="header" class="clearfix">
              <span>组员相关</span>
            </div>
            <div style="margin-bottom:50px;">
              <div class="filter-container">
                <el-select v-model="temp_user_ids" :remote-method="getRemoteUserList" filterable remote
                         value-key="id"
                         placeholder="用户" style="width: 220px">
                <el-option v-for="(item,index) in userListOptions" :key="item+index" :label="item.id + ':' + item.name" :value="item.id"/>
              </el-select>

                <el-button v-waves class="filter-item" type="primary" icon="el-icon-edit" @click="appendUser">添加
                </el-button>
                <el-button v-waves class="filter-item" type="primary" icon="el-icon-delete" @click="delUser">移除
                </el-button>
              </div>
              <el-table :data="data" border fit highlight-current-row style="width: 100%"
                        ref="multipleTable" @selection-change="handleSelectionChange">
                <el-table-column type="selection" width="76" align="center"></el-table-column>
                <el-table-column align="center" label="用户ID ">
                  <template slot-scope="scope">
                    <router-link :to="'/push/edit/'+scope.row.user_id" class="link-type">
                      <span>{{ scope.row.user_id }}</span>
                    </router-link>
                  </template>
                </el-table-column>
                <el-table-column align="center" label="用户名">
                  <template slot-scope="scope">
                    <span>{{ scope.row.nick_name }}</span>
                  </template>
                </el-table-column>
                <el-table-column align="center" label="联系电话">
                  <template slot-scope="scope">
                    <span>{{ scope.row.phone }}</span>
                  </template>
                </el-table-column>
                <el-table-column align="center" label="发布帖子数">
                  <template slot-scope="scope">
                    <span>{{ scope.row.topic_nums }}</span>
                  </template>
                </el-table-column>
                <el-table-column align="center" label="用户身份">
                  <template slot-scope="scope">
                    <span>{{ scope.row.user_identify }}</span>
                  </template>
                </el-table-column>
                <el-table-column align="center" label="组内身份" v-if="isEdit">
                  <template slot-scope="scope">
                    <span>{{ scope.row.group_identify }}</span>
                  </template>
                </el-table-column>

              </el-table>

              <pagination v-show="total>0" :total="total" :page="listQuery.page" :limit="listQuery.limit"
                          style="margin-left: 250px;" @pagination="getList"/>
            </div>
          </el-card>
        </el-row>


      </div>
    </el-form>

  </div>
</template>

<script>
  import MDinput from '@/components/MDinput'
  import Sticky from '@/components/Sticky' // 粘性header组件
  import waves from '@/directive/waves'
  import Pagination from '@/components/Pagination'

  import {createGroup, GroupDetail, fetchGroupRelateduser, GroupUserDetail} from '@/api/group'
  import {starSearch, userSearch} from '@/api/remoteSearch'

  import { isInArray, removeByvale} from "@/utils";

  function Assembledata(target, source) {
    var region_data = []
    console.log(target, source)
    for (var i=0;i<target.length;i++){
      if (isInArray(source, target[i]['name'])){
        region_data.push(target[i]['id'])
        removeByvale(source, target[i]['name']);
      }
    }
    region_data.push(...source)
    return region_data.join(',')
  }

  const defaultForm = {
    status: 'draft',
    name: '', // 小组名称
    description: '', // 小组简介
    id: undefined,
    user_nums: 0,
    user_id: '',
    star: [],
    is_online: 1,
    is_recommend: 1,
    user_ids: [],
  }

  export default {
    name: 'GroupDetail',
    components: {MDinput, Sticky, Pagination},
    directives: {waves},
    props: {
      isEdit: {
        type: Boolean,
        default: false
      }
    },
    data() {
      const validateRequire = (rule, value, callback) => {
        if (value === '') {
          this.$message({
            message: rule.field + '为必传项',
            type: 'error'
          })
          callback(new Error(rule.field + '为必传项'))
        } else {
          callback()
        }
      }
      return {
        postForm: Object.assign({}, defaultForm),
        loading: false,
        rules: {
          title: [{validator: validateRequire}],
          content: [{validator: validateRequire}],
        },
        tempRoute: {},
        temp_user_ids: '',
        user_ids: [],
        starListOptions: [],
        userListOptions: [],

        // 小组相关
        list: null,
        tableData: [],
        temp:{
          user_id: '',
          user_name: '',
          user_ids: [],
          star_ids: [],
        },
        del_list: [],
        total: 0,
        listLoading: true,
        multipleSelection: [],
        listQuery: {
          page: 0,
          limit: 10,
          filter: {
            value: '',
            key: '',
          },
        },
      }
    },
    computed: {
      contentShortLength() {
        return this.postForm.description.length
      },
      data() {
        return this.tableData.filter((d) => {
          let is_del = false;
          for (let i = 0; i < this.del_list.length; i++) {
            if (d.user_id == this.del_list[i].user_id) {
              is_del = true;
              break
            }
          }
          if (!is_del) {
            return d
          }
        })
      }
    },
    created() {
      if (this.isEdit) {
        const id = this.$route.params && this.$route.params.id
        this.fetchData(id)
        this.getList()
      } else {
        this.postForm = Object.assign({}, defaultForm)
      }

      this.tempRoute = Object.assign({}, this.$route)
    },
    methods: {
      fetchData(id) {
        GroupDetail(id).then(response => {
          let rep = response.data.data
          let temp_star_list = []
          this.postForm = response.data.data

          this.temp.user_id = rep.creator.id
          this.postForm.user_id = this.temp.user_name = rep.creator.name

          // TODO
          for (let i = 0;i < rep.star.length; i++){
            temp_star_list.push(rep.star[i]['name'])

            this.temp.star_ids.push(rep.star[i])
          }
          this.postForm.star = temp_star_list
        }).catch(err => {
          console.log(err)
        })
      },
      submitForm() {
        this.$refs.postForm.validate(valid => {
          if (valid) {
            this.loading = true
            if (this.postForm.user_id === this.temp.user_name){
              this.postForm.user_id = this.temp.user_id
            }
            let user_ids = []
            for (let i = 0;i < this.tableData.length; i++){
              user_ids.push(this.tableData[i].user_id)
            }
            if (this.isEdit){
              this.postForm.star = Assembledata(this.temp.star_ids, this.postForm.star)
            }
            this.postForm.user_ids = JSON.stringify(user_ids);
            createGroup(this.postForm).then(response => {
              this.$notify({
                title: '成功',
                message: response.data.data.message,
                type: 'success',
                duration: 2000
              })
              setTimeout(() => {
                this.$router.push('/group/list')
              }, 1000)

            }).catch(err => {
              this.$notify({
                title: '失败',
                message: '操作失败',
                type: 'danger',
                duration: 2000
              })
            });


            this.postForm.status = 'published'
            this.loading = false
          } else {
            console.log('error submit!!')
            return false
          }
        })
      },
      // 添加组员相关
      handleSelectionChange(val) {
        this.multipleSelection = val;
      },
      handleSizeChange(val) {
        this.listQuery.limit = val
        this.getList()
      },
      handleCurrentChange(val) {
        this.listQuery.page = val
        this.getList()
      },
      appendUser() {
        if (isInArray(this.user_ids, this.temp_user_ids)) {
          this.$message({
            message: '数据添加重复',
            type: 'error'
          })
          return false;
        }
        GroupUserDetail(this.temp_user_ids).then(response => {
          if (!response.data.data) return
          this.tableData.push(...response.data.data)
          this.total = this.tableData.length
        })
        this.user_ids.push(this.temp_user_ids)
        this.temp_user_ids = ''
      },
      delUser() {
        this.del_list.push(...this.multipleSelection)
      },
      getList() {
        this.listLoading = true
         this.listQuery.id = this.$route.params && this.$route.params.id
        fetchGroupRelateduser(this.listQuery).then(response => {
          let rep = response.data.data.data
          this.tableData = response.data.data.data
          this.total = response.data.data.total
          for (let i=0;i<rep.length;i++){
            this.user_ids.push(rep[i].user_id)
          }

          this.listLoading = false
        })
      },

      // 远程搜索
      getRemoteUserList(query) {
        userSearch(query).then(response => {
          if (!response.data.data.data) return
          this.userListOptions = response.data.data.data
        })
      },
      getRemoteStarList(query) {
        starSearch(query).then(response => {
          if (!response.data.data.data) return
          this.starListOptions = response.data.data.data
          console.log(response.data.data.data)
        })
      },
    }
  }
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
  @import "src/styles/mixin.scss";

  .createPost-container {
    position: relative;
    .createPost-main-container {
      padding: 40px 45px 20px 50px;
      .postInfo-container {
        position: relative;
        @include clearfix;
        margin-bottom: 10px;
        .postInfo-container-item {
          float: left;
        }
      }
      .editor-container {
        min-height: 500px;
        margin: 0 0 30px;
        .editor-upload-btn-container {
          text-align: right;
          margin-right: 10px;
          .editor-upload-btn {
            display: inline-block;
          }
        }
      }
    }
    .word-counter {
      width: 40px;
      position: absolute;
      right: -10px;
      top: 0px;
    }
  }
</style>
